//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "typ.h"
#include "fce.h"
#include "cfg.h"
#include "main.h"
#include "port.h"
#include "about.h"
#include "registrace.h"
#include "ulozmereni.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

unsigned int datain[6];
TPacient pacient;
TDoktor doktor;
TGraf *graf, *grafm1, *grafm2;
TInfo info;
TCasovac Timer;
int kresli=0;
TMeritko meritko;
TForm1 *Form1;

//----konstruktor------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  Application->OnException=&Vyjimka;
  Bitmap1=new Graphics::TBitmap();Bitmap1->Width=PaintBox1->Width;Bitmap1->Height=PaintBox1->Height;
  Bitmap2=new Graphics::TBitmap();Bitmap2->Width=PaintBox2->Width;Bitmap2->Height=PaintBox2->Height;
  Ismazat(PaintBox1);Ismazat(PaintBox2);
  PageControl1->ActivePage=TabSheet1;
  Form1->ActiveControl=Edit1;
  info.Dlogged=false;graf=NULL;info.Msaved=true;info.Plogged=false;info.nemenit=false;
  info.Pzmeneno=false;
  doktor.delka=6;
  info.Prior=1;
  info.Kalib[0]=0;
  info.Kalib[1]=0;
  info.Kalib[2]=0;
  info.Kalib[3]=0;
  info.Kalib[4]=0;
  Button21Click(this); // reset meritka
}

//----vyjimka----------------------------------------------------------------
void __fastcall TForm1::Vyjimka(TObject* Sender, Exception* E)
{
  if (AnsiString(E->ClassName())=="EDBEditError") {
    Application->MessageBox("patn zadan rodn slo.","Chyba!",MB_OK|MB_ICONINFORMATION);
    MaskEdit1->Clear();
    MaskEdit1->SetFocus();
  } else if (AnsiString(E->ClassName())=="EPrinter") {
    Application->MessageBox("Chyba pstupu k tisku. Pravdpodobn nen nainstalovna tiskrna.","Chyba!",MB_OK|MB_ICONWARNING);
  } else {
    if (E && Sender) {
      if (Application->MessageBox("Nastala neznm chyba v programu, pejete si pesto pokraovat?",AnsiString("Chyba! ("+E->ClassName()+","+((TControl*)Sender)->Name+")").c_str(),MB_YESNO|MB_ICONERROR)==ID_NO) Close();
    } else {
      if (Application->MessageBox("Nastala neznm chyba v programu, pejete si pesto pokraovat?","Chyba!",MB_YESNO|MB_ICONERROR)==ID_NO) Close();
    }
  }
}

//----about------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Form2->ShowModal();
}

//----prihlaseni prihlaseni--------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if (Edit1->Text=="") {
    Application->MessageBox("Nebylo zadno jmno!","Pihlen",MB_ICONWARNING|MB_OK);
    Edit1->SetFocus();
  } else
  if (Edit2->Text=="") {
    Application->MessageBox("Nebylo zadno heslo!","Pihlen",MB_ICONWARNING|MB_OK);
    Edit2->SetFocus();
  } else
  if (DRLogin(Edit1->Text.c_str(),Edit2->Text.c_str())) {
    Edit2->Enabled=false;Edit1->Enabled=false;Button2->Enabled=false;Button3->Enabled=true;Button8->Enabled=true;
    info.Dlogged=true;
    DRSaveLast(doktor.login);
    PageControl1->ActivePage=TabSheet2;
    MaskEdit1->Enabled=true;MaskEdit1->SetFocus();
  } else {
    Application->MessageBox("patn jmno nebo heslo!","Pihlen",MB_ICONWARNING|MB_OK);
    Edit2->Text="";
    Edit1->SetFocus();
  }
}

//----prihlaseni odhlaseni---------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
    if (PLogout()) {
      Edit2->Enabled=true;Edit2->Text="";
      Edit1->Enabled=true;Edit1->Text="";
      Button2->Enabled=true;
      Button3->Enabled=false;
      Button8->Enabled=false;
      info.Dlogged=false;
      Edit1->SetFocus();
      Form1->ListBox1->Clear();
      MaskEdit1->Enabled=false;
//      DRUpdate(doktor);
      doktor.delka=6;
      info.Prior=1;
      Form5->CheckBox1->Checked=false;
    }
}

//----mereni domereno--------------------------------------------------------
void __fastcall TForm1::Idomereno(void) {
  Timer.Stop();
  info.Ton=false;
  Port.Close();
  Priorita(2);
  Button6->Enabled=true;
  Button4->Caption="&Start";
  if (info.Plogged) { Button16->Enabled=true;Button5->Enabled=true;}
  info.Ton=true;
  Label3->Caption="x";Label4->Caption="x";Label5->Caption="x";Label6->Caption="x";Label7->Caption="x";Label8->Caption="0";
  info.nemenit=false;info.Msaved=false;
  ComboBox1Click(this);
  Vykresli();
  Beep();
}

//----smazani grafu----------------------------------------------------------
void __fastcall TForm1::Ismazat(TPaintBox *im, int posun) {
  Graphics::TBitmap *btmp;
  if (im==PaintBox1) btmp=Bitmap1; else btmp=Bitmap2;
  btmp->Canvas->Brush->Color=clWhite;
  btmp->Canvas->FillRect(Rect(0,0,btmp->Width,btmp->Height));
  btmp->Canvas->Pen->Color=clLtGray;
  for (int i=0;i<btmp->Width-1+posun;i=i+20) {
    btmp->Canvas->MoveTo(i,0);
    btmp->Canvas->LineTo(i,btmp->Height);
  }
  for (int i=btmp->Height-1;i>0;i=i-20) {
    btmp->Canvas->MoveTo(0,i);
    btmp->Canvas->LineTo(btmp->Width,i);
  }
  btmp->Canvas->Pen->Color=clBlack;

  TRect r;
  btmp->Canvas->CopyMode = cmWhiteness;
  r = Rect(0, 0, btmp->Width, btmp->Height);

  im->Canvas->CopyRect(r, btmp->Canvas, r);
  btmp->Canvas->CopyMode = cmSrcCopy;
}

//----timer------------------------------------------------------------------
void __fastcall TForm1::Casovac(TMessage& Msg)
{
   if (Timer.Started) {
      GetData();
      for (int i=1; i<=5; i++) {
        datain[i]=datain[i]-info.Kalib[i-1];
        if (datain[i]>255) datain[i]=0;
      }
      int pos=datain[0]-(600*(info.nasobic-1));
      if (!kresli)
        for (int i=1; i<=5; i++) {
          PaintBox1->Canvas->Pixels[pos][PaintBox1->Height-datain[i]-1] = clBlack;
          Bitmap1->Canvas->Pixels[pos][PaintBox1->Height-datain[i]-1] = clBlack;
        }
      else {
        if (info.Ton){
          info.Ton=false;
          PaintBox1->Canvas->MoveTo(pos,PaintBox1->Height-datain[kresli]-1);
          Bitmap1->Canvas->MoveTo(pos,PaintBox1->Height-datain[kresli]-1);
        }
        PaintBox1->Canvas->LineTo(pos,PaintBox1->Height-datain[kresli]-1);
        Bitmap1->Canvas->LineTo(pos,Bitmap1->Height-datain[kresli]-1);
      }
      Label3->Caption=datain[1];Label4->Caption=datain[2];Label5->Caption=datain[3];Label6->Caption=datain[4];Label7->Caption=datain[5];
      Label8->Caption=datain[0];

      graf->DataIn(datain[0],datain[1],datain[2],datain[3],datain[4],datain[5]);
      if (++datain[0]>info.max) {Timer.Stop();Idomereno();return;}
      if (datain[0]>600*info.nasobic) {
       info.nasobic++;
       Ismazat(PaintBox1);
       info.Ton=true;
      }
   }
}

//----mereni start-----------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  if (Button4->Caption=="&Start") {
    if (!strcmp(info.Ccom,"dn") || !Port.Open(info.Ccom)) {
      Vyjimka2(6);
      Button6->SetFocus();
      return;
    };
    Ismazat(PaintBox1);
    datain[0]=0;
    Button4->Caption="S&top";
    info.nemenit=true;
    Button16->Enabled=false;
    Button5->Enabled=false;
    Button6->Enabled=false;
    Label18->Caption="0";
    Priorita(info.Prior);

    if (graf) delete graf;
    graf=new TGraf;
    info.Ton=true;

    info.max=doktor.delka*100;
    info.nasobic=1;
    GetData(); //vezmu prvni a zahodim
    Timer.Start(10);
  } else Idomereno();
}

//----graf souradnice--------------------------------------------------------
void __fastcall TForm1::PaintBox2MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  Label9->Caption=AnsiString((int)((X/meritko.X)*10))+"ms";
  Label10->Caption=(int)((PaintBox2->Height-(Y+1))/meritko.Y-ScrollBar3->Position+ScrollBar3->Max);
}

//----graf vykresleni---------------------------------------------------------
void __fastcall TForm1::Vykresli()
{
// max, nasobic
  Ismazat(PaintBox2,(ScrollBar3->Max-ScrollBar3->Position)*meritko.Y);
  typedef struct {TCheckBox *chb; TLabel *lbl;} Tchb;
  Tchb c[13]; //0 je vynechana
  c[1].chb=CheckBox1;c[2].chb=CheckBox2;c[3].chb=CheckBox3;c[4].chb=CheckBox4;c[5].chb=CheckBox5;c[6].chb=CheckBox6;
  c[7].chb=CheckBox7;c[8].chb=CheckBox8;c[9].chb=CheckBox9;c[10].chb=CheckBox10;c[11].chb=CheckBox11;c[12].chb=CheckBox12;
  c[1].lbl=Label12;c[2].lbl=Label13;c[3].lbl=Label14;c[4].lbl=Label15;c[5].lbl=Label16;c[6].lbl=Label17;
  c[7].lbl=Label31;c[8].lbl=Label32;c[9].lbl=Label33;c[10].lbl=Label34;c[11].lbl=Label35;c[12].lbl=Label36;
  for (int i=7;i<13;i++) {
    if ((grafm2) && c[i].chb->Checked) {
      grafm2->Prvni();

      while (grafm2->Dalsi() && grafm2->Cas()<ScrollBar2->Position) {}

      Bitmap2->Canvas->MoveTo((grafm2->Cas()-ScrollBar2->Position)*meritko.X,Bitmap2->Height-(grafm2->Data(i-6)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);
      if (i==12) Bitmap2->Canvas->MoveTo((grafm2->Cas()-ScrollBar2->Position)*meritko.X,Bitmap2->Height-(grafm2->Prumer(CheckBox13->Checked,CheckBox14->Checked,CheckBox15->Checked,CheckBox16->Checked,CheckBox17->Checked)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);
      Bitmap2->Canvas->Pen->Color=c[i].lbl->Font->Color;
      while (grafm2->Dalsi()) {
        switch (i) {
          case 7: case 8: case 9: case 10: case 11: Bitmap2->Canvas->LineTo((grafm2->Cas()-ScrollBar2->Position)*meritko.X,Bitmap2->Height-(grafm2->Data(i-6)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);break;
          case 12: Bitmap2->Canvas->LineTo((grafm2->Cas()-ScrollBar2->Position)*meritko.X,Bitmap2->Height-(grafm2->Prumer(CheckBox13->Checked,CheckBox14->Checked,CheckBox15->Checked,CheckBox16->Checked,CheckBox17->Checked)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);break;
        }
      }
    }
  }
  for (int i=1;i<7;i++) {
    if ((grafm1) && c[i].chb->Checked) {
      grafm1->Prvni();

      while (grafm1->Dalsi() && grafm1->Cas()<ScrollBar1->Position) {}

      Bitmap2->Canvas->MoveTo((grafm1->Cas()-ScrollBar1->Position)*meritko.X,Bitmap2->Height-(grafm1->Data(i)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);
      if (i==6) Bitmap2->Canvas->MoveTo((grafm1->Cas()-ScrollBar1->Position)*meritko.X,Bitmap2->Height-(grafm1->Prumer(CheckBox13->Checked,CheckBox14->Checked,CheckBox15->Checked,CheckBox16->Checked,CheckBox17->Checked)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);
      Bitmap2->Canvas->Pen->Color=c[i].lbl->Font->Color;
      while (grafm1->Dalsi()) {
        switch (i) {
          case 1: case 2: case 3: case 4: case 5: Bitmap2->Canvas->LineTo((grafm1->Cas()-ScrollBar1->Position)*meritko.X,Bitmap2->Height-(grafm1->Data(i)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);break;
          case 6: Bitmap2->Canvas->LineTo((grafm1->Cas()-ScrollBar1->Position)*meritko.X,Bitmap2->Height-(grafm1->Prumer(CheckBox13->Checked,CheckBox14->Checked,CheckBox15->Checked,CheckBox16->Checked,CheckBox17->Checked)+ScrollBar3->Position-ScrollBar3->Max)*meritko.Y-1);break;
        }
      }
    }
  }
  PaintBoxPaint(PaintBox2);
}

//----zmena barvy------------------------------------------------------------
void __fastcall TForm1::LabelClick(TObject *Sender)
{
    TLabel *tmp;
    tmp = (TLabel*) Sender;
    ColorDialog1->Color=tmp->Font->Color;
    if (ColorDialog1->Execute()) tmp->Font->Color=ColorDialog1->Color;
    Vykresli();
}

//----tisk-------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
    PrintDialog1= new TPrintDialog(this);
    if(PrintDialog1->Execute()) {
      Printer()->Title="Perineometr";
      Printer()->BeginDoc();
      int radek=0;
      long y=0;
      if (info.Plogged) {
        Printer()->Canvas->Font->Name="MS Sans Serif";
        Printer()->Canvas->Font->Size=8;
        radek++;
        Printer()->Canvas->TextOut(20,radek*Printer()->Canvas->TextHeight(pacient.jmeno),AnsiString(AnsiString(pacient.prijmeni)+" "+AnsiString(pacient.jmeno)+", R:"+AnsiString(pacient.rc)));
        radek++;
        radek++;
        Printer()->Canvas->TextOut(20,radek*Printer()->Canvas->TextHeight("\n"),"\n");
      }
      y=Printer()->Canvas->PenPos.y;
//      TRect d = Rect(200,y,Bitmap2->Width+200,Bitmap2->Height+y);
//      Bitmap2->Canvas->CopyMode = cmSrcCopy;
//      TRect z = Rect(0, 0, Bitmap2->Width, Bitmap2->Height);
      int sirka=Bitmap2->Width*4+100;
      int vyska=Bitmap2->Height*4+y;
      if (Bitmap2->Width*4+100>Printer()->PageWidth && Bitmap2->Height*4+y>Printer()->PageHeight) {
        sirka=Bitmap2->Width;vyska=Bitmap2->Height;
      }
      TRect d = Rect(100,y,sirka,vyska);
      Printer()->Canvas->StretchDraw(d, Bitmap2);
//      Printer()->Canvas->CopyRect(d, Bitmap2->Canvas, z);
      Printer()->EndDoc();
    }
    delete PrintDialog1;
}

//----prekresleni------------------------------------------------------------
void __fastcall TForm1::PaintBoxPaint(TObject *Sender)
{
  TPaintBox *tmp;
  Graphics::TBitmap *btmp;
  tmp = (TPaintBox*) Sender;
  if (tmp==PaintBox1) btmp=Bitmap1; else btmp=Bitmap2;

  TRect r;
  btmp->Canvas->CopyMode = cmWhiteness;
  r = Rect(0, 0, btmp->Width, btmp->Height);
  tmp->Canvas->CopyRect(r, btmp->Canvas, r);
  btmp->Canvas->CopyMode = cmSrcCopy;
}

//----destructor-------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
  delete Bitmap1;delete Bitmap2;
}

//----prihlaseni smazataktiv-------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{
  Decode(doktor.heslo);
  Form3->Edit2->Text=doktor.heslo;Form3->Edit3->Text=doktor.heslo;
  Code(doktor.heslo);
  Form3->Edit1->Text=doktor.login;
  Form3->Edit4->Text=doktor.jmeno;Form3->Edit5->Text=doktor.prijmeni;
  Form3->Button3->Visible=true;
  Form3->Edit1->Enabled=false;
  Form3->ActiveControl=Form3->Edit4;
  Form3->ShowModal();
}

//----prihlaseni newuser-----------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
  Form3->Button3->Visible=false;
  Form3->Edit1->Enabled=true;
  Form3->Edit1->Text="";Form3->Edit2->Text="";Form3->Edit3->Text="";
  Form3->Edit4->Text="";Form3->Edit5->Text="";
  Form3->ActiveControl=Form3->Edit1;
  Form3->ShowModal();
}

//----vyber pacienta zmenit udaje------------------------------------------
void __fastcall TForm1::Button11Click(TObject *Sender)
{
  Edit3->Enabled=true;Edit4->Enabled=true;Edit5->Enabled=true;Edit6->Enabled=true;
  Edit7->Enabled=true;Edit8->Enabled=true;Edit9->Enabled=true;Edit10->Enabled=true;
  Button14->Enabled=false;Memo1->Enabled=true;Button11->Enabled=false;Edit6->SetFocus();
  Button15->Enabled=true;Button17->Visible=true;
  info.nemenit=true;
}

//----vyber pacienta---------------------------------------------------------
void __fastcall TForm1::MaskEdit1Change(TObject *Sender)
{
  if (MaskEdit1->GetTextLen()==10) {
    MaskEdit1->ValidateEdit();
    if (PLogin(MaskEdit1->EditText.c_str())) {
      if (Application->MessageBox(AnsiString("Nalezen pacient "+AnsiString(pacient.prijmeni)+" "+AnsiString(pacient.jmeno)+" - souhlas?").c_str(),"Nalezen pacient",MB_ICONQUESTION|MB_YESNO)==ID_YES) {
        Edit10->Text=pacient.psc;Edit9->Text=pacient.mesto;Edit8->Text=pacient.cp;Edit7->Text=pacient.ulice;
        Edit4->Text=pacient.prijmeni;Edit3->Text=pacient.jmeno;Edit5->Text=pacient.titul;Edit6->Text=pacient.pojistovna;
        Button11->Enabled=true;Memo1->Enabled=false;MaskEdit1->Enabled=false;
        Button16->Enabled=!info.Msaved;
        Button5->Enabled=!info.Msaved;
        Button17->Visible=false;
        AnsiString name=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+".mem");
        if (FileExists(name)) Memo1->Lines->LoadFromFile(name);
        Button13->Enabled=false;Button15->Enabled=false;Button14->Enabled=true;info.Pzmeneno=false;
        PageControl1->ActivePage=TabSheet3;
        PageControl1Change(PageControl1);
      } else {
        PLogout();
        MaskEdit1->Clear();MaskEdit1->SetFocus();
      }
    } else {
      if (Application->MessageBox("Pacient nen v evidenci - registrovat?","Neznm pacient",MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2)==ID_YES) {
        info.nemenit=true;
        Button16->Enabled=!info.Msaved;
        Button5->Enabled=!info.Msaved;
        Button14->Enabled=false;MaskEdit1->Enabled=false;Button11->Enabled=false;
        Edit3->Enabled=true;Edit4->Enabled=true;Edit5->Enabled=true;Edit6->Enabled=true;
        Edit7->Enabled=true;Edit8->Enabled=true;Edit9->Enabled=true;Edit10->Enabled=true;
        Edit3->SetFocus();Memo1->Enabled=true;Button15->Enabled=true;Button13->Enabled=true;
      }
      else {
        MaskEdit1->Clear();MaskEdit1->SetFocus();
      }
    }
  }
}

//----ulozit mereni----------------------------------------------------------
void __fastcall TForm1::Button16Click(TObject *Sender)
{
  MSave();MListbox();
}

//----pacienti zmena udaju---------------------------------------------------
void __fastcall TForm1::EditChange(TObject *Sender)
{
  Button13->Enabled=true;Button15->Enabled=true;Button14->Enabled=false;info.Pzmeneno=true;
}

//----pacienti zrusit zmeny--------------------------------------------------
void __fastcall TForm1::Button15Click(TObject *Sender)
{
  if (info.Pzmeneno)
   if(Application->MessageBox("Skuten si pejete zruit proveden zmny?","Zmna daj",MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2)==ID_NO) return;
   else {
    if (!info.Plogged) {MaskEdit1->Clear();MaskEdit1->Enabled=true;MaskEdit1->SetFocus();}
    if (!PLogin(pacient.rc)) {
      Form1->Edit10->Text="ps";Form1->Edit9->Text="msto";Form1->Edit8->Text="p";Form1->Edit7->Text="ulice";
      Form1->Edit4->Text="pjmen";Form1->Edit3->Text="jmno";Form1->Edit5->Text="";Form1->Edit6->Text="";
      Form1->Memo1->Lines->Clear();Form1->Memo1->Lines->Add("poznmky:");
    } else {;
      Edit10->Text=pacient.psc;Edit9->Text=pacient.mesto;Edit8->Text=pacient.cp;Edit7->Text=pacient.ulice;
      Edit4->Text=pacient.prijmeni;Edit3->Text=pacient.jmeno;Edit5->Text=pacient.titul;Edit6->Text=pacient.pojistovna;
      AnsiString name=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+".mem");
      if (FileExists(name)) Memo1->Lines->LoadFromFile(name);
    }
   };
  if (!info.Plogged) {MaskEdit1->Enabled=true;MaskEdit1->Clear();MaskEdit1->SetFocus();}
  Button11->Enabled=true;Memo1->Enabled=false;Button14->Enabled=true;
  Button13->Enabled=false;Button15->Enabled=false;Button11->Enabled=true;
  Edit3->Enabled=false;Edit4->Enabled=false;Edit5->Enabled=false;Edit6->Enabled=false;
  Edit7->Enabled=false;Edit8->Enabled=false;Edit9->Enabled=false;Edit10->Enabled=false;
  Button14->Enabled=true;info.nemenit=false;info.Pzmeneno=false;
  Memo1->Enabled=false;Button17->Visible=false;
}

//-----pacienti ulozit zmeny-------------------------------------------------
void __fastcall TForm1::Button13Click(TObject *Sender)
{
  Button13->Enabled=false;Button15->Enabled=false;Button11->Enabled=true;
  Edit3->Enabled=false;Edit4->Enabled=false;Edit5->Enabled=false;Edit6->Enabled=false;
  Edit7->Enabled=false;Edit8->Enabled=false;Edit9->Enabled=false;Edit10->Enabled=false;
  Button14->Enabled=true;info.nemenit=false;
  Memo1->Enabled=false;Button17->Visible=false;info.Pzmeneno=false;
  strcpy(pacient.rc,MaskEdit1->EditText.c_str());
  strcpy(pacient.jmeno,Edit3->Text.c_str());strcpy(pacient.prijmeni,Edit4->Text.c_str());
  strcpy(pacient.ulice,Edit7->Text.c_str());strcpy(pacient.cp,Edit8->Text.c_str());
  strcpy(pacient.mesto,Edit9->Text.c_str());strcpy(pacient.psc,Edit10->Text.c_str());
  strcpy(pacient.titul,Edit5->Text.c_str());strcpy(pacient.pojistovna,Edit6->Text.c_str());
  info.Plogged=true;
  PUpdate(pacient);
}

//-----pacienti zmena pacienta-----------------------------------------------
void __fastcall TForm1::Button14Click(TObject *Sender)
{
  if (PLogout()) MaskEdit1->SetFocus();
}

//----pacienti smazat pacienta-----------------------------------------------
void __fastcall TForm1::Button17Click(TObject *Sender)
{
  if (Application->MessageBox("Skuten si pejete smazat pacienta vetn vech daj a men?","Mazn",MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2)==ID_YES) {
    PDelete(pacient.rc);
    PLogout();
    info.nemenit=false;info.Pzmeneno=false;
    MaskEdit1->SetFocus();
  }
}

//----pacienti editace a meneni fokusu--------------------------------------
void __fastcall TForm1::PageControl1Changing(TObject *Sender, bool &AllowChange)
{
 if (((TPageControl *)Sender)->ActivePage == TabSheet2) {
    AllowChange = !info.nemenit;
    if (info.nemenit)
      Application->MessageBox("Nejprve potvrte nebo zrute proveden zmny.","Pacienti",MB_ICONINFORMATION|MB_OK);
 } else if (((TPageControl *)Sender)->ActivePage == TabSheet3) {
    AllowChange = !info.nemenit;
    if (info.nemenit) Beep();
 } else
    AllowChange = true;
}

//----mereni co kreslit------------------------------------------------------
void __fastcall TForm1::RadioButtonClick(TObject *Sender)
{
  info.Ton=true;
  if (Sender==RadioButton1) kresli=1;
  else if (Sender==RadioButton2) kresli=2;
  else if (Sender==RadioButton3) kresli=3;
  else if (Sender==RadioButton4) kresli=4;
  else if (Sender==RadioButton5) kresli=5;
  else if (Sender==RadioButton6) kresli=0;
}

//----konec------------------------------------------------------------------
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  CanClose=true;
  if (Timer.Started) {CanClose=false;Beep();return;}
  if (!PLogout()) CanClose=false;
  else if (info.Dlogged)
  DRUpdate(doktor);
}

//----prihlaseni prvni spusteni----------------------------------------------
void __fastcall TForm1::PageControl1Enter(TObject *Sender)
{ if (!info.Dlogged) {
    if (!Struktura("data")) {
      Application->MessageBox("Prvn sputn programu, zaregistrujte prosm novho uivatele.","Poprv",MB_ICONINFORMATION|MB_OK);
      Button9->SetFocus();
    }
    DRLoadLast(doktor.login);
    CLoadLast(info.Ccom);
    Edit1->Text=doktor.login;
  }
}

//-----mazani mereni---------------------------------------------------------
void __fastcall TForm1::Button20Click(TObject *Sender)
{
  if (Application->MessageBox(AnsiString("Skuten si pejete smazat men ze dne "+Label18->Caption+" ?").c_str(),"Mazn",MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2)==ID_YES) {
    MDelete(ListBox1->Items->Count-ListBox1->ItemIndex-1);
    Form1->Memo2->Lines->Clear();
    Form1->Label18->Caption="";Form1->Label19->Caption="";Form1->Label20->Caption="";Form1->Label11->Caption="";
    ListBox1Click(this);
  }
}

//-----mereni nastaveni------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
  Form5->ComboBox1->ItemIndex=Form5->ComboBox1->Items->IndexOf(info.Ccom);
  Form5->Edit2->Text=doktor.delka;
  Form5->ShowModal();
  TabSheet3Enter(this);
}                                 

//-----listbox zmena---------------------------------------------------------
void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
  MListboxMemo(ListBox1->Items->Count-ListBox1->ItemIndex-1);
}

//----graf s aktualem--------------------------------------------------------
void __fastcall TForm1::ComboBox1Click(TObject *Sender)
{
  if (grafm1) {delete grafm1;grafm1=NULL;}
  if (!grafm1) grafm1=new TGraf;
  if (ComboBox1->ItemIndex==0 || ComboBox1->ItemIndex==-1) {
    if(!MLoad(grafm1,graf)) {delete grafm1;grafm1=NULL;}
  } else {
    if (!MLoad(grafm1,ComboBox2->Items->Count-ComboBox1->ItemIndex-1)) {delete grafm1;grafm1=NULL;}
  }
  if (grafm1) ScrollBar1->Max=grafm1->CasCelkem();
  else ScrollBar1->Max=0;
  if ((grafm1 || grafm2) && meritko.Y>1)
  {
    ScrollBar3->Max=255-255/meritko.Y;
//    ScrollBar3->Position=ScrollBar3->Max;
  } else
  {
    ScrollBar3->Position=0;
    ScrollBar3->Max=0;
  }
  Vykresli();
}

//----graf porovnani---------------------------------------------------------
void __fastcall TForm1::ComboBox2Click(TObject *Sender)
{
  if (grafm2) {delete grafm2;grafm2=NULL;}
  if (!grafm2) grafm2=new TGraf;
  if (ComboBox2->ItemIndex==0) {delete grafm2;grafm2=NULL;}
  else {
    if (!MLoad(grafm2,ComboBox2->Items->Count-ComboBox2->ItemIndex-1)) {delete grafm2;grafm2=NULL;}
  }
  if (grafm2) ScrollBar2->Max=grafm2->CasCelkem();
  else ScrollBar2->Max=0;
  if ((grafm1 || grafm2) && meritko.Y>1)
  {
    ScrollBar3->Max=255-255/meritko.Y;
//    ScrollBar3->Position=ScrollBar3->Max;
  } else
  {
    ScrollBar3->Position=0;
    ScrollBar3->Max=0;
  }
  Vykresli();
}

//----graf zmena co vykreslit------------------------------------------------
void __fastcall TForm1::CheckBoxClick(TObject *Sender)
{
  if (Sender==CheckBox6 || Sender==CheckBox12)
  {
    if (CheckBox6->Checked || CheckBox12->Checked)
    {
      CheckBox13->Enabled=true;CheckBox14->Enabled=true;CheckBox15->Enabled=true;
      CheckBox16->Enabled=true;CheckBox17->Enabled=true;
    } else
    {
      CheckBox13->Enabled=false;CheckBox14->Enabled=false;CheckBox15->Enabled=false;
      CheckBox16->Enabled=false;CheckBox17->Enabled=false;
    }
  }
  Vykresli();
}

//----mereni prvni spusteni--------------------------------------------------
void __fastcall TForm1::PageControl1Change(TObject *Sender)
{
 if (((TPageControl *)Sender)->ActivePage == TabSheet3) {
   if (!FileExists("data\\cfg.per")) {
    Application->MessageBox("Prvn sputn programu, provete prosm nastaven sondy.","Poprv",MB_ICONINFORMATION|MB_OK);
    Button6->SetFocus();
  }
 }
}

//----graf hejbnuti skrolem--------------------------------------------------
void __fastcall TForm1::ScrollBarChange(TObject *Sender)
{
  Vykresli();
  Label43->Caption=AnsiString((int)(255/meritko.Y)-ScrollBar3->Position+ScrollBar3->Max);
  Label44->Caption=AnsiString((int)(0/meritko.Y)-ScrollBar3->Position+ScrollBar3->Max);
}

//----ulozit mereni----------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
  Button16Click(this);
}

//----mereni zmena napisu kalibrace------------------------------------------
void __fastcall TForm1::TabSheet3Enter(TObject *Sender)
{
  Label26->Caption="A: "+AnsiString(info.Kalib[0]);
  Label27->Caption="B: "+AnsiString(info.Kalib[1]);
  Label28->Caption="C: "+AnsiString(info.Kalib[2]);
  Label29->Caption="D: "+AnsiString(info.Kalib[3]);
  Label30->Caption="E: "+AnsiString(info.Kalib[4]);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button21Click(TObject *Sender)
{
  Label9->Caption="0ms";
  Label10->Caption=0;
  ScrollBar1->Position=0;
  ScrollBar2->Position=0;
  ScrollBar3->Position=0;
  meritko.x1=1;meritko.x2=1;meritko.y1=1;meritko.y2=1;
  meritko.X=1;meritko.Y=1;
  Meritko();
  Vykresli();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button19Click(TObject *Sender)
{
  if (meritko.x1>1) meritko.x1--;
  else if (meritko.x2<15) meritko.x2++;
  meritko.X=(float)meritko.x1/(float)meritko.x2;
  Meritko();
  Vykresli();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button18Click(TObject *Sender)
{
  if (meritko.x2>1) meritko.x2--;
  else if (meritko.x1<15) meritko.x1++;
  meritko.X=(float)meritko.x1/(float)meritko.x2;
  Meritko();
  Vykresli();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
  if (meritko.y1>1) meritko.y1--;
  else if (meritko.y2<3) meritko.y2++;
  meritko.Y=(float)meritko.y1/(float)meritko.y2;
  Meritko();
  Vykresli();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
  bool zezad=false;
  if (meritko.y1==1 && meritko.y2==1) zezad=true;
  if (meritko.y2>1) meritko.y2--;
  else if (meritko.y1<10) meritko.y1++;
  meritko.Y=(float)meritko.y1/(float)meritko.y2;
  if (zezad)
  {
    ScrollBar3->Max=255-255/meritko.Y;
    ScrollBar3->Position=ScrollBar3->Max;
  }
  Meritko();
  Vykresli();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Meritko()
{
  if (grafm1) ScrollBar1->Max=grafm1->CasCelkem();
  else ScrollBar1->Max=0;
  if (grafm2) ScrollBar2->Max=grafm2->CasCelkem();
  else ScrollBar2->Max=0;
  if ((grafm1 || grafm2) && meritko.Y>1) ScrollBar3->Max=255-255/meritko.Y;
  else ScrollBar3->Max=0;
  Label39->Caption="X: "+AnsiString(meritko.x1)+":"+AnsiString(meritko.x2);
  Label40->Caption="Y: "+AnsiString(meritko.y1)+":"+AnsiString(meritko.y2);
  Label42->Caption=AnsiString((int)(6000/meritko.X));
  Label43->Caption=AnsiString((int)(255/meritko.Y)-ScrollBar3->Position+ScrollBar3->Max);
  Label44->Caption=AnsiString((int)(0/meritko.Y)-ScrollBar3->Position+ScrollBar3->Max);
}


void __fastcall TForm1::Button22Click(TObject *Sender)
{
  MListboxMemoEdit(ListBox1->Items->Count-ListBox1->ItemIndex-1);
}
//---------------------------------------------------------------------------

