//---------------------------------------------------------------------------


#pragma hdrstop

#include "main.h"
#include "ulozmereni.h"
#include "typ.h"
#include "fce.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void Vyjimka2(int i) {
  switch (i) {
    case 0: Application->MessageBox("Under construction","Nehotovo!",MB_ICONWARNING|MB_OK);break;
    case 1: Application->MessageBox("Nemohu zapisovat na disk.","Chyba!",MB_ICONERROR|MB_OK);break;
    case 2: Application->MessageBox("Chyba pi pstupu na disk.","Chyba!",MB_ICONERROR|MB_OK);break;
    case 3: Application->MessageBox("Chyba pi updatovn databze.","Chyba!",MB_ICONERROR|MB_OK);break;
    case 4: Application->MessageBox("Chyba pi pstupu do databze.","Chyba!",MB_ICONERROR|MB_OK);break;
    case 5: Application->MessageBox("dn men nen aktivn.","Chyba!",MB_ICONERROR|MB_OK);break;
    case 6: Application->MessageBox("Pipojen na tomto portu nen mon. Zkuste nastavit jin port.","Chyba!",MB_ICONERROR|MB_OK);break;
//    case 7: Application->MessageBox("Na tomto portu nen pipojena podporovan verze sondy.","Chyba!",MB_ICONERROR|MB_OK);break;
    default: if (Application->MessageBox("Nastala neznm chyba v programu, pejete si pesto pokraovat?","Chyba!",MB_YESNO|MB_ICONERROR)==ID_NO) Form1->Close();break;
  }
}


bool CopyFile(char* kam, char* co) {
  HANDLE fh=CreateFile(co,GENERIC_READ,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  HANDLE fhzal=CreateFile(kam,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE || fhzal==INVALID_HANDLE_VALUE) {
    CloseHandle(fhzal);
    CloseHandle(fh);
    return false;
  }
  char buf[255];
  DWORD precet,zapsal;
  while (ReadFile(fh,buf,sizeof(buf),&precet,NULL),precet) {
    WriteFile(fhzal,buf,precet,&zapsal,NULL);
    if (precet!=zapsal) {
      CloseHandle(fhzal);
      CloseHandle(fh);
      return false;
    }
  }
  CloseHandle(fhzal);
  CloseHandle(fh);
  return true;
}

bool SmazZFile(char *kam, char *co, DWORD poskam, const DWORD kolik) {
  HANDLE fh=CreateFile(co,GENERIC_READ,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  HANDLE fhzal=CreateFile(kam,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE || fhzal==INVALID_HANDLE_VALUE) {
    CloseHandle(fhzal);
    CloseHandle(fh);
    return false;
  }
  char buf[255];
  DWORD precet,zapsal,pos,kol;
  bool stav=true;
  while (ReadFile(fh,buf,sizeof(buf),&precet,NULL),precet) {
    pos=SetFilePointer(fh,0,NULL,FILE_CURRENT);
    if (stav) {
        if (poskam>pos) kol=precet;
        else {
          kol=precet-(pos-poskam);stav=1;stav=false;
          Tpozice pozice;
          int o=pos-poskam-kolik;
          pozice.celkova=-o;
          SetFilePointer(fh,pozice.nizsi,&pozice.vyssi,FILE_CURRENT);
          pos=SetFilePointer(fh,0,NULL,FILE_CURRENT);
        }
        WriteFile(fhzal,buf,kol,&zapsal,NULL);
        if (kol!=zapsal) {
          CloseHandle(fhzal);
          CloseHandle(fh);
          CopyFile(co,kam);
          return false;
        };
     } else {
        WriteFile(fhzal,buf,precet,&zapsal,NULL);
        if (precet!=zapsal) {
          CloseHandle(fhzal);
          CloseHandle(fh);
          CopyFile(co,kam);
          return false;
        };
     };
  }
  CloseHandle(fhzal);
  CloseHandle(fh);
  return true;
}

bool Struktura(char *i) {
    if (!DirectoryExists(i)) {
      if (!CreateDir(i)) Vyjimka2(1);
      return false;
    } else return true;
}

void DRLoadLast(char *i) {
  HANDLE fh=CreateFile("data\\last.per",GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    strcpy(i,"");
  } else {
    DWORD precet;
    if (!ReadFile(fh,i,9,&precet,NULL)) strcpy(i,"");
    CloseHandle(fh);
  }
}

void CLoadLast(char *i) {
  HANDLE fh=CreateFile("data\\cfg.per",GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    strcpy(i,"dn");
  } else {
    DWORD precet;
    if (!ReadFile(fh,i,5,&precet,NULL)) strcpy(i,"");
    if (strcmp(i,"COM1") && strcmp(i,"COM2") && strcmp(i,"COM3") && strcmp(i,"COM4")) strcpy(i,"dn");
    CloseHandle(fh);
  }
}

void DRSaveLast(char *i) {
  HANDLE fh=CreateFile("data\\last.per",GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh!=INVALID_HANDLE_VALUE) {
    DWORD zapsal;
    WriteFile(fh,i,strlen(i),&zapsal,NULL);
    CloseHandle(fh);
    if (zapsal!=strlen(i)) {
      if (FileExists("data\\last.per")) DeleteFile("data\\last.per");
      Vyjimka2(1);
    }
  } else Vyjimka2(1);
}

void CSaveLast(char *i) {
  HANDLE fh=CreateFile("data\\cfg.per",GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh!=INVALID_HANDLE_VALUE) {
    DWORD zapsal;
    WriteFile(fh,i,strlen(i),&zapsal,NULL);
    CloseHandle(fh);
    if (zapsal!=strlen(i)) {
      if (FileExists("data\\cfg.per")) DeleteFile("data\\cfg.per");
      Vyjimka2(1);
    }
  } else Vyjimka2(1);
}

void SmazVsechno() {
    TSearchRec sr;
    if (FindFirst("*.*", faAnyFile, sr) == 0) {
      do {
        if (sr.Attr==faDirectory && sr.Name!="." && sr.Name!="..") {

          TSearchRec sr2;
          if (FindFirst(sr.Name+"\\*.*", faAnyFile, sr2) == 0) {
            do {
               if (sr2.Name!="." && sr2.Name!="..") if (!DeleteFile(sr.Name+"\\"+sr2.Name)) Vyjimka2(2);
            } while (FindNext(sr2) == 0);
            FindClose(sr2);
          } else Vyjimka2(2);
          if (!RemoveDir(sr.Name)) Vyjimka2(2);

        } else if (sr.Name!="." && sr.Name!="..") if (!DeleteFile(sr.Name)) Vyjimka2(2);
      } while (FindNext(sr) == 0);
      FindClose(sr);
    } else Vyjimka2(2);
}

void DRDelete (char *kdo) {
  info.Msaved=true;PLogout();

  AnsiString current=GetCurrentDir();
  if (SetCurrentDir("data\\"+AnsiString(doktor.adresar))) {
    SmazVsechno();
    if (SetCurrentDir(current) && SetCurrentDir("data")) {
      if (!RemoveDir(doktor.adresar)) Vyjimka2(2);
    } else Vyjimka2(4);
    if (!SetCurrentDir(current)) Vyjimka2(2);
  } else Vyjimka2(4);

  CopyFile("data\\drszal.per","data\\drs.per");
  HANDLE fh=CreateFile("data\\drs.per",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    Vyjimka2(2);
    CloseHandle(fh);
    return;
  }
  DWORD precet;
  union {
    TDoktor dr;
    char tmp[sizeof(TDoktor)];
  } drcet;
  while (ReadFile(fh,drcet.tmp,sizeof(TDoktor),&precet,NULL),precet) {
    if (!strcmp(drcet.dr.login,kdo)) {
      DWORD oo=SetFilePointer(fh,0,NULL,FILE_CURRENT);
      CloseHandle(fh);
      if (!SmazZFile("data\\drs.per","data\\drszal.per",oo-sizeof(TDoktor),sizeof(TDoktor))) {
        Vyjimka2(2);
        CloseHandle(fh);
        return;
      };
      return;
    }
  }
  CloseHandle(fh);
  return;
};

bool DRExist (char *kdo) {
  HANDLE fh=CreateFile("data\\drs.per",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    Vyjimka2(2);
    CloseHandle(fh);
    return false;
  }
  DWORD precet;
  union {
    TDoktor dr;
    char tmp[sizeof(TDoktor)];
  } drcet;
  while (ReadFile(fh,drcet.tmp,sizeof(TDoktor),&precet,NULL),precet) {
    if (!strcmp(drcet.dr.login,kdo)) {
      CloseHandle(fh);
      return true;
    }
  }
  CloseHandle(fh);
  return false;
}

void DRUpdate (TDoktor dr) {
  union {
    TDoktor dr;
    char tmp[sizeof(TDoktor)];
  } drcet;
  if (!CopyFile("data\\drszal.per","data\\drs.per")) Vyjimka2(2);
  HANDLE fh=CreateFile("data\\drs.per",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    Vyjimka2(2);
    return;
  }
//  strcpy(doktor.jmeno,dr.jmeno);
//  strcpy(doktor.prijmeni,dr.prijmeni);
  DWORD precet;
  while (ReadFile(fh,drcet.tmp,sizeof(TDoktor),&precet,NULL),precet) {
    if (!strcmp(drcet.dr.login,dr.login)) {
      strcpy(dr.adresar,drcet.dr.adresar);
      Tpozice pozice;      int o=sizeof(TDoktor);
      pozice.celkova=-o;
      SetFilePointer(fh,pozice.nizsi,&pozice.vyssi,FILE_CURRENT);
      drcet.dr=dr;
      WriteFile(fh,drcet.tmp,sizeof(TDoktor),&precet,NULL);
      CloseHandle(fh);
      if (precet!=sizeof(TDoktor)) {
          if (!CopyFile("data\\drs.per","data\\drszal.per")) Vyjimka2(2);
          Vyjimka2(1);
      }
      return;
    }
  }
  //vymysli adresar
  int unsigned i;
  for (i=0;i<=99999999;i++) {
    if (!DirectoryExists(AnsiString("data\\"+AnsiString(i)))) {
      if (!CreateDir(AnsiString("data\\"+AnsiString(i)))) {Vyjimka2(1);break;}
      break;
    }
  } if (i==99999999) Vyjimka2(3);

  strcpy(dr.adresar,AnsiString(i).c_str());
  drcet.dr=dr;
  WriteFile(fh,drcet.tmp,sizeof(TDoktor),&precet,NULL);
  CloseHandle(fh);
  if (precet!=sizeof(TDoktor)) {
    if (!CopyFile("data\\drs.per","data\\drszal.per")) Vyjimka2(2);
    Vyjimka2(1);
  }
  return;
};

void Code(char *h) {
  for (int i=0;h[i];i++) {
    h[i]=255 ^ h[i];
  }
}

void Decode(char *h) {
  for (int i=0;h[i];i++) {
    h[i]=255 ^ h[i];
  }
}

bool DRLogin(char *i, char *heslo) {
  HANDLE fh=CreateFile("data\\drs.per",GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  union {
    TDoktor dr;
    char tmp[sizeof(TDoktor)];
  } drcet;

  if (fh==INVALID_HANDLE_VALUE) {
    return false;
  } else {
    DWORD precet;
    while (ReadFile(fh,drcet.tmp,sizeof(TDoktor),&precet,NULL),precet) {
      if (!strcmp(drcet.dr.login,i)) {
        Code(heslo);
        if (!strcmp(drcet.dr.heslo,heslo)) {
          strcpy(doktor.login,i);strcpy(doktor.heslo,heslo);strcpy(doktor.adresar,drcet.dr.adresar);
          strcpy(doktor.jmeno,drcet.dr.jmeno);strcpy(doktor.prijmeni,drcet.dr.prijmeni);doktor.delka=drcet.dr.delka;
          CloseHandle(fh);
//          info.Msaved=true;
//          Form1->Ismazat(Form1->PaintBox1);Form1->Ismazat(Form1->PaintBox2);
          MListbox();
          return true;
        }
      }
    }
  }
  CloseHandle(fh);
  return false;
}

bool PLogin(char* i) {
  if (!Struktura(AnsiString("data\\"+AnsiString(doktor.adresar)).c_str())) {
    Vyjimka2(4);
    return false;
  }
  HANDLE fh=CreateFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str(),GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    return false;
  } else {
    union {
      TPacient pac;
      char tmp[sizeof(TPacient)];
    } paccet;
    DWORD precet;
    while (ReadFile(fh,paccet.tmp,sizeof(TPacient),&precet,NULL),precet) {
      if (!strcmp(paccet.pac.rc,i)) {
        strcpy(pacient.rc,i);
        strcpy(pacient.pojistovna,paccet.pac.pojistovna);
        strcpy(pacient.titul,paccet.pac.titul);
        strcpy(pacient.jmeno,paccet.pac.jmeno);
        strcpy(pacient.prijmeni,paccet.pac.prijmeni);
        strcpy(pacient.ulice,paccet.pac.ulice);
        strcpy(pacient.mesto,paccet.pac.mesto);
        strcpy(pacient.cp,paccet.pac.cp);
        strcpy(pacient.psc,paccet.pac.psc);
        strcpy(pacient.adresar,paccet.pac.adresar);
        CloseHandle(fh);
        info.Plogged=true;
        MListbox();
        return true;
      }
    }
  }
  CloseHandle(fh);
  return false;
}

bool PLogout(void) {
  if ((graf) && !info.Msaved && info.Plogged) {
    UINT u=Application->MessageBox("Pejete si uloit proveden men?","Men",MB_ICONQUESTION|MB_YESNOCANCEL|MB_DEFBUTTON1);
    switch (u) {
      case ID_YES: if (!MSave()) return false;PLogout();break;
      case ID_CANCEL: return false;
    }
  }
  if (graf) delete graf;graf=NULL;
  info.Msaved=true;Form1->Button16->Enabled=false;
  strcpy(info.Maktual,"-1");
  Form1->Button5->Enabled=false;
  
  info.Plogged=false;MListbox();
  Form1->Edit10->Enabled=false;Form1->Edit9->Enabled=false;Form1->Edit8->Enabled=false;Form1->Edit7->Enabled=false;
  Form1->Edit6->Enabled=false;Form1->Edit5->Enabled=false;Form1->Edit4->Enabled=false;Form1->Edit3->Enabled=false;
  Form1->MaskEdit1->Enabled=true;Form1->MaskEdit1->Clear();
  Form1->Memo1->Enabled=false;
  Form1->Edit10->Text="ps";Form1->Edit9->Text="msto";Form1->Edit8->Text="p";Form1->Edit7->Text="ulice";
  Form1->Edit4->Text="pjmen";Form1->Edit3->Text="jmno";Form1->Edit5->Text="";Form1->Edit6->Text="";
  Form1->Memo1->Lines->Clear();Form1->Memo1->Lines->Add("poznmky:");
  Form1->Memo2->Lines->Clear();Form1->Memo2->Lines->Add("poznmky:");
  Form1->Button17->Visible=false;
  Form1->Button11->Enabled=false;Form1->Button13->Enabled=false;Form1->Button15->Enabled=false;
    Form1->Memo2->Lines->Clear();
    Form1->Label20->Caption="";
    Form1->Label11->Caption="";
    Form1->Label19->Caption="";Form1->Label18->Caption="";
  Form1->Ismazat(Form1->PaintBox1);Form1->Ismazat(Form1->PaintBox2);
  if (grafm1) {delete grafm1;grafm1=NULL;}
  if (grafm2) {delete grafm2;grafm2=NULL;}
  Form1->ScrollBar1->Max=0;
  Form1->ScrollBar2->Max=0;  
  return true;
}

void PUpdate (TPacient pac) {
  union {
    TPacient pac;
    char tmp[sizeof(TPacient)];
  } paccet;
  if (!CopyFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\paczal.per").c_str(),AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str())) Vyjimka2(2);
  HANDLE fh=CreateFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str(),GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    Vyjimka2(2);
    return;
  }
  DWORD precet;
  while (ReadFile(fh,paccet.tmp,sizeof(TPacient),&precet,NULL),precet) {
    if (!strcmp(paccet.pac.rc,pac.rc)) {
      strcpy(pac.adresar,paccet.pac.adresar);
      Tpozice pozice;      
      int o=sizeof(TPacient);
      pozice.celkova=-o;
      SetFilePointer(fh,pozice.nizsi,&pozice.vyssi,FILE_CURRENT);
      paccet.pac=pac;
      WriteFile(fh,paccet.tmp,sizeof(TPacient),&precet,NULL);
      CloseHandle(fh);
      if (precet!=sizeof(TPacient)) {
          if (!CopyFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str(),AnsiString("data\\"+AnsiString(doktor.adresar)+"\\paczal.per").c_str())) Vyjimka2(2);
          Vyjimka2(1);
      }
      Form1->Memo1->Lines->SaveToFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pac.adresar)+".mem"));
      MListbox();
      return;
    }
  }
  //vymysli adresar
  int unsigned i;
  for (i=0;i<=99999999;i++) {
    if (!DirectoryExists(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(i)))) {
      if (!CreateDir(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(i)))) {Vyjimka2(1);break;}
      break;
    }
  } if (i==99999999) Vyjimka2(3);

  strcpy(pac.adresar,AnsiString(i).c_str());
  strcpy(pacient.adresar,pac.adresar);
  paccet.pac=pac;
  WriteFile(fh,paccet.tmp,sizeof(TPacient),&precet,NULL);
  CloseHandle(fh);
  if (precet!=sizeof(TPacient)) {
    if (!CopyFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str(),AnsiString("data\\"+AnsiString(doktor.adresar)+"\\paczal.per").c_str())) Vyjimka2(2);
    Vyjimka2(1);
  }
  Form1->Memo1->Lines->SaveToFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+".mem"));
  MListbox();
  return;
};

void PDelete (char *kdo) {
  AnsiString current=GetCurrentDir();
  if (SetCurrentDir("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar))) {
    SmazVsechno();
    if (SetCurrentDir(current) && SetCurrentDir("data\\"+AnsiString(doktor.adresar))) {
      if (!RemoveDir(pacient.adresar)) Vyjimka2(2);
    } else Vyjimka2(4);
    //
    if (!SetCurrentDir(current)) Vyjimka2(2);
  } else Vyjimka2(4);
  AnsiString name=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+".mem");
  if (FileExists(name)) if (!DeleteFile(name)) Vyjimka2(2);
  CopyFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\paczal.per").c_str(),AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str());
  HANDLE fh=CreateFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str(),GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    Vyjimka2(2);
    CloseHandle(fh);
    return;
  }
  DWORD precet;
  union {
    TPacient dr;
    char tmp[sizeof(TPacient)];
  } drcet;
  while (ReadFile(fh,drcet.tmp,sizeof(TPacient),&precet,NULL),precet) {
    if (!strcmp(drcet.dr.rc,kdo)) {
      DWORD oo=SetFilePointer(fh,0,NULL,FILE_CURRENT);
      CloseHandle(fh);
      if (!SmazZFile(AnsiString("data\\"+AnsiString(doktor.adresar)+"\\pac.per").c_str(),AnsiString("data\\"+AnsiString(doktor.adresar)+"\\paczal.per").c_str(),oo-sizeof(TPacient),sizeof(TPacient))) {
        Vyjimka2(2);
        CloseHandle(fh);
        return;
      };
      info.Plogged=false;
      return;
    }
  }
  CloseHandle(fh);
  info.Plogged=false;
  return;
}

bool MSavep(char *name) {
  if (!graf) return false;
  union {
    T5dat data;
    char tmp[sizeof(T5dat)];
  } dcet;
  HANDLE fh=CreateFile(AnsiString(AnsiString(name)+".mer").c_str(),GENERIC_READ|GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE) {
    Vyjimka2(2);
    return false;
  }
  graf->Prvni();
  DWORD precet;
  dcet.data=graf->Aktual();
  WriteFile(fh,dcet.tmp,sizeof(T5dat),&precet,NULL);
  if (precet!=sizeof(T5dat)) Vyjimka2(1);
  while (graf->Dalsi()) {
    dcet.data=graf->Aktual();
    WriteFile(fh,dcet.tmp,sizeof(T5dat),&precet,NULL);
    if (precet!=sizeof(T5dat)) Vyjimka2(1);
  }
  CloseHandle(fh);
  Form4->Memo1->Lines->SaveToFile(AnsiString(AnsiString(name)+".mem"));
  return true;
};

bool MSave() {
  if (graf) {
   Form4->Memo1->Lines->Clear();Form4->Memo1->Lines->Add("poznmky:");
   Form4->Label2->Caption=TimeToStr(graf->datum);
   Form4->Label1->Caption=DateToStr(graf->datum);
   if (Form4->ShowModal()==mrYes) {
    AnsiString path=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+"\\");
    if (!CopyFile(AnsiString(path+"merzal.per").c_str(),AnsiString(path+"mer.per").c_str())) Vyjimka2(2);
    HANDLE fh=CreateFile(AnsiString(path+"mer.per").c_str(),GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
    if (fh==INVALID_HANDLE_VALUE) {
      Vyjimka2(2);
      return false;
    }
    DWORD precet;
    int unsigned i;
    for (i=0;i<=99999999;i++) {
      if (!FileExists(AnsiString(path+AnsiString(i)+".mer"))) {
        if (!MSavep(AnsiString(path+AnsiString(i)).c_str())) {Vyjimka2(1);break;}
        break;
      }
    } if (i==99999999) Vyjimka2(3);
    Tmercet mercet;
    strcpy(mercet.mer.datum,FormatDateTime("dd.mm.yyyy",graf->datum).c_str());
    strcpy(mercet.mer.cas,FormatDateTime("hh:mm",graf->datum).c_str());
    strcpy(mercet.mer.adresar,AnsiString(i).c_str());
    strcpy(info.Maktual,mercet.mer.adresar);
    SetFilePointer(fh,0,NULL,FILE_END);
    WriteFile(fh,mercet.tmp,sizeof(Tmercet),&precet,NULL);
    CloseHandle(fh);
    if (precet!=sizeof(Tmercet)) {
        if (!CopyFile(AnsiString(path+"mer.per").c_str(),AnsiString(path+"merzal.per").c_str())) Vyjimka2(2);
        Vyjimka2(1);
    }
     info.Msaved=true;
     Form1->Button16->Enabled=false;
     Form1->Button5->Enabled=false;
     return true;
   }
   return false;
  } else Vyjimka2(5);
  return false;
}

void MListboxMemoEdit(int i) {
   Tmercet mercet;
   DWORD precet;
   AnsiString path=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+"\\");

    HANDLE fh=CreateFile(AnsiString(path+"mer.per").c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    if (fh==INVALID_HANDLE_VALUE) return;
    Tpozice pozice;
    int o=sizeof(Tmercet);
    pozice.celkova=o*i;
    SetFilePointer(fh,pozice.nizsi,&pozice.vyssi,FILE_BEGIN);
    if (ReadFile(fh,mercet.tmp,sizeof(Tmercet),&precet,NULL),precet) {
      CloseHandle(fh);
      if (precet!=sizeof(Tmercet)) {Vyjimka2(4);return;}
      Form4->Label1->Caption=mercet.mer.datum;
      Form4->Label2->Caption=mercet.mer.cas;
//      strcpy(info.MLBadresar,mercet.mer.adresar);
    } else {CloseHandle(fh);return;}


   if (FileExists(AnsiString(path+mercet.mer.adresar+".mem")))
   {
     Form4->Memo1->Lines->LoadFromFile(AnsiString(path+mercet.mer.adresar)+".mem");
   } else
   {
     Form4->Memo1->Lines->Clear();Form4->Memo1->Lines->Add("poznmky:");
   }
   if (Form4->ShowModal()==mrYes)
   {
     Form4->Memo1->Lines->SaveToFile(AnsiString(path+mercet.mer.adresar)+".mem");
     MListboxMemo(i);
   }
}

void MListboxMemo(int i) {
  if (info.Plogged && info.Dlogged) {
    Form1->Label20->Caption=pacient.prijmeni;
    Form1->Label11->Caption=pacient.jmeno;
    Form1->Label19->Caption="";Form1->Label18->Caption="";
    AnsiString path=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+"\\");
    Tmercet mercet;
    DWORD precet;
    HANDLE fh=CreateFile(AnsiString(path+"mer.per").c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    if (fh==INVALID_HANDLE_VALUE) return;
    Tpozice pozice;
    int o=sizeof(Tmercet);
    pozice.celkova=o*i;
    SetFilePointer(fh,pozice.nizsi,&pozice.vyssi,FILE_BEGIN);
    if (ReadFile(fh,mercet.tmp,sizeof(Tmercet),&precet,NULL),precet) {
      CloseHandle(fh);
      if (precet!=sizeof(Tmercet)) {Vyjimka2(4);return;}
      Form1->Label18->Caption=mercet.mer.datum;Form1->Label19->Caption=mercet.mer.cas;
      strcpy(info.MLBadresar,mercet.mer.adresar);
      if (FileExists(AnsiString(path+mercet.mer.adresar+".mem"))) Form1->Memo2->Lines->LoadFromFile(AnsiString(path+mercet.mer.adresar)+".mem"); else Form1->Memo2->Lines->Clear();
    } else {CloseHandle(fh);return;}
  } else {
    Form1->Memo2->Lines->Clear();
    Form1->Label20->Caption="";
    Form1->Label11->Caption="";
    Form1->Label19->Caption="";Form1->Label18->Caption="";
  }
}

void Mlistboxp() {
      Form1->ComboBox1Click(NULL);
      Form1->ListBox1->Clear();Form1->ComboBox1->Clear();Form1->ComboBox2->Clear();
      Form1->Button20->Enabled=false;
      Form1->Button22->Enabled=false;      
      Form1->ComboBox1->Items->Add("aktuln men");Form1->ComboBox1->ItemIndex=0;
      Form1->ComboBox2->Items->Add("dn");Form1->ComboBox2->ItemIndex=0;
}

void MListbox() {
   DWORD precet;
    Tmercet mercet;
    if (info.Plogged) {
      Form1->ListBox1->Clear();Form1->ComboBox1->Clear();Form1->ComboBox2->Clear();Form1->Button20->Enabled=false;Form1->Button22->Enabled=false;
      AnsiString path=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+"\\");
      HANDLE fh=CreateFile(AnsiString(path+"mer.per").c_str(),GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
      if (fh==INVALID_HANDLE_VALUE) {Mlistboxp();return;}
      while (ReadFile(fh,mercet.tmp,sizeof(Tmercet),&precet,NULL),precet) {
       if (precet!=sizeof(Tmercet)) {CloseHandle(fh);Mlistboxp();return;}
      Form1->ListBox1->Items->Add(AnsiString(AnsiString(mercet.mer.datum)+" - "+mercet.mer.cas));
      Form1->Button20->Enabled=true;
      Form1->Button22->Enabled=true;
      }
//obratit poradi
      int last=Form1->ListBox1->Items->Count-1;
      if (last>0) for (int i=0; i<=div((last+1),2).quot-1; i++) Form1->ListBox1->Items->Exchange(i,last-i);
      CloseHandle(fh);
      Form1->ListBox1->ItemIndex=0;
      MListboxMemo(Form1->ListBox1->Items->Count-Form1->ListBox1->ItemIndex-1);
      Form1->ComboBox1->Items->Assign(Form1->ListBox1->Items);
      Form1->ComboBox2->Items->Assign(Form1->ListBox1->Items);
      Form1->ComboBox1->Items->Add("aktuln men");
      Form1->ComboBox2->Items->Add("dn");
//aktual a zadne na zacatek
      last=Form1->ComboBox1->Items->Count-1;
      if (last>0) for (int i=last; i>0; i--) Form1->ComboBox1->Items->Exchange(i,i-1);
      Form1->ComboBox1->ItemIndex=0;Form1->ComboBox1Click(NULL);
      last=Form1->ComboBox2->Items->Count-1;
      if (last>0) for (int i=last; i>0; i--) Form1->ComboBox2->Items->Exchange(i,i-1);
      Form1->ComboBox2->ItemIndex=0;Form1->ComboBox2Click(NULL);
    } else Mlistboxp();
}

void MDelete(int i) {
  if (i!=-1) {
      if ((info.Msaved) && (!strcmp(info.Maktual,info.MLBadresar))) {
        info.Msaved=false;Form1->Button16->Enabled=true;
        Form1->Button5->Enabled=true;
      }
      Tmercet mercet;
      AnsiString path=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+"\\");
      if (!CopyFile(AnsiString(path+"merzal.per").c_str(),AnsiString(path+"mer.per").c_str())) {Vyjimka2(2);return;}
      if (!SmazZFile(AnsiString(path+"mer.per").c_str(),AnsiString(path+"merzal.per").c_str(),sizeof(Tmercet)*i,sizeof(Tmercet))) {Vyjimka2(2);return;};
      if (FileExists(AnsiString(path+AnsiString(info.MLBadresar)+".mer").c_str())) DeleteFile(AnsiString(path+AnsiString(info.MLBadresar)+".mer").c_str());
      if (FileExists(AnsiString(path+AnsiString(info.MLBadresar)+".mem").c_str())) DeleteFile(AnsiString(path+AnsiString(info.MLBadresar)+".mem").c_str());
      MListbox();
  }
}
bool MLoad(TGraf *graf1, TGraf *graf2) {
 if ((graf1) && (graf2)) {
   graf1->datum=graf2->datum;
   graf2->Prvni();
   graf1->DataIn(graf2->Aktual().data[5],graf2->Aktual().data[0],graf2->Aktual().data[1],graf2->Aktual().data[2],graf2->Aktual().data[3],graf2->Aktual().data[4]);
   while (graf2->Dalsi()) {
     graf1->DataIn(graf2->Aktual().data[5],graf2->Aktual().data[0],graf2->Aktual().data[1],graf2->Aktual().data[2],graf2->Aktual().data[3],graf2->Aktual().data[4]);
   }
   return true;
  } else return false;
}

bool MLoad(TGraf *graf, int i) {
  if (graf) {
    AnsiString path=AnsiString("data\\"+AnsiString(doktor.adresar)+"\\"+AnsiString(pacient.adresar)+"\\");
    Tmercet mercet;
    DWORD precet;
    HANDLE fh=CreateFile(AnsiString(path+"mer.per").c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    if (fh==INVALID_HANDLE_VALUE) return false;
    Tpozice pozice;
    int o=sizeof(Tmercet);
    pozice.celkova=o*i;
    SetFilePointer(fh,pozice.nizsi,&pozice.vyssi,FILE_BEGIN);
    if (ReadFile(fh,mercet.tmp,sizeof(Tmercet),&precet,NULL),precet) {
      CloseHandle(fh);
      if (precet!=sizeof(Tmercet)) {Vyjimka2(4);return false;}
      strcpy(info.MLBadresar,mercet.mer.adresar);
      if (FileExists(AnsiString(path+mercet.mer.adresar+".mer"))) {
      HANDLE fh=CreateFile(AnsiString(path+mercet.mer.adresar+".mer").c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
      if (fh==INVALID_HANDLE_VALUE) return false;
        union {
          T5dat data;
          char tmp[sizeof(T5dat)];
        } dcet;
        graf->Prvni();
        while (ReadFile(fh,dcet.tmp,sizeof(T5dat),&precet,NULL),precet) {
          if (precet!=sizeof(T5dat)) {Vyjimka2(4);return false;}
          graf->DataIn(dcet.data.data[5],dcet.data.data[0],dcet.data.data[1],dcet.data.data[2],dcet.data.data[3],dcet.data.data[4]);
        }
        CloseHandle(fh);
        return true;
      } else {CloseHandle(fh);return false;}
    } else {CloseHandle(fh);return false;}
  } else return false;
}

